Name:           perl-Perl-Critic
Version:        1.05
Release:        2%{?dist}
Summary:        Critique Perl source code for best-practices
Group:          Development/Libraries
License:        GPL+ or Artistic
URL:            http://search.cpan.org/dist/Perl-Critic/
Source0:        https://cpan.metacpan.org/authors/id/T/TH/THALJEF/perlcritic/Perl-Critic-%{version}.tar.gz
Patch0:         Perl-Critic-1.05-678628c8.patch
Patch1:         Perl-Critic-1.05-rt30139.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:      noarch
# Module Build
BuildRequires:  coreutils
BuildRequires:  perl
BuildRequires:  perl(Module::Build)
# Module Runtime
BuildRequires:  perl(B::Keywords) >= 1.05
BuildRequires:  perl(base)
BuildRequires:  perl(Carp)
BuildRequires:  perl(charnames)
BuildRequires:  perl(Config::Tiny) >= 2
BuildRequires:  perl(English)
BuildRequires:  perl(Exporter)
BuildRequires:  perl(File::Basename)
BuildRequires:  perl(File::Find)
BuildRequires:  perl(File::Path)
BuildRequires:  perl(File::Spec)
BuildRequires:  perl(File::Spec::Unix)
BuildRequires:  perl(File::Temp)
BuildRequires:  perl(IO::String)
BuildRequires:  perl(List::MoreUtils)
BuildRequires:  perl(List::Util)
BuildRequires:  perl(overload)
BuildRequires:  perl(Pod::PlainText)
BuildRequires:  perl(PPI) >= 1.118
BuildRequires:  perl(PPI::Document)
BuildRequires:  perl(PPI::Document::File)
BuildRequires:  perl(PPI::Token::Whitespace)
BuildRequires:  perl(Scalar::Util)
BuildRequires:  perl(strict)
BuildRequires:  perl(String::Format) >= 1.13
BuildRequires:  perl(warnings)
# Script Runtime
BuildRequires:  perl(Getopt::Long)
BuildRequires:  perl(Pod::Usage)
# Test Suite
BuildRequires:  perl(lib)
BuildRequires:  perl(PPI::Cache)
BuildRequires:  perl(Test::More)
# Optional Tests (Devel::EnforceEncapsulation not available in EPEL-5)
BuildRequires:  perl(Test::Memory::Cycle)
# Author Tests
BuildRequires:  perl(File::Which)
BuildRequires:  perl(Test::Kwalitee)
BuildRequires:  perl(Test::Perl::Critic)
BuildRequires:  perl(Test::Pod) >= 1.00
BuildRequires:  perl(Test::Pod::Coverage) >= 1.04
BuildRequires:  perl(Test::Spelling), aspell-en
# Dependencies
Requires:       perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
# Optional Functionality
BuildRequires:  perl(ExtUtils::Manifest)
BuildRequires:  perl(File::HomeDir)
BuildRequires:  perl(Module::Pluggable) >= 3.1
BuildRequires:  perl(Perl::Tidy)
BuildRequires:  perl(Term::ANSIColor)
Requires:       perl(ExtUtils::Manifest)
Requires:       perl(File::HomeDir)
Requires:       perl(Module::Pluggable) >= 3.1
Requires:       perl(Perl::Tidy)
Requires:       perl(Term::ANSIColor)

%description
Perl::Critic is an extensible framework for creating and applying coding
standards to Perl source code. Essentially, it is a static source code
analysis engine. Perl::Critic is distributed with a number of
Perl::Critic::Policy modules that attempt to enforce various coding
guidelines. Most Policy modules are based on Damian Conway's book Perl
Best Practices. However, Perl::Critic is not limited to PBP and will
even support Policies that contradict Conway. You can enable, disable,
and customize those Polices through the Perl::Critic interface. You can
also create new Policy modules that suit your own tastes.

%prep
%setup -q -n Perl-Critic-%{version}

# Don't rely on the behavior of all() when the list is empty (CPAN RT#63816)
%patch0

# Fix expected failure count for multiple glob test in
# BuiltinFunctions::RequireGlobFunction, changed with later version of PPI
# (CPAN RT#30139)
%patch1

%build
perl Build.PL --installdirs=vendor
./Build

%install
rm -rf %{buildroot}
./Build install --destdir=%{buildroot} --create_packlist=0
%{_fixperms} %{buildroot}

%check
LANG=en_US TEST_AUTHOR=1 ./Build test

%clean
rm -rf %{buildroot}

%files
%doc Changes LICENSE README TODO.pod
%{_bindir}/perlcritic
%{perl_vendorlib}/Perl/
%{_mandir}/man1/perlcritic.1*
%{_mandir}/man3/Perl::Critic*.3*

%changelog
* Thu Jan 21 2016 Paul Howarth <paul@city-fan.org> - 1.05-2
- Don't rely on the behavior of all() when the list is empty (CPAN RT#63816)
- Fix expected failure count for multiple glob test in
  BuiltinFunctions::RequireGlobFunction, changed with later version of PPI
  (CPAN RT#30139)
- Fix license tag
- Fix source URL to point to MetaCPAN, where it can still be found
- Classify buildreqs by usage
- Run tests with LANG=en_US so spell check works properly
- Drop %%defattr, redundant since rpm 4.4
- Don't use macros for commands
- Make %%files list more explicit
- Use %%{_fixperms} macro rather than our own chmod incantation

* Tue Mar 20 2007 Jose Pedro Oliveira <jpo at di.uminho.pt> - 1.05-1
- Update to 1.05.

* Thu Feb 15 2007 Jose Pedro Oliveira <jpo at di.uminho.pt> - 1.03-1
- Update to 1.03.

* Fri Jan 26 2007 Jose Pedro Oliveira <jpo at di.uminho.pt> - 1.01-2
- Bumping release (forgot to commit sources and .cvsignore changes).

* Fri Jan 26 2007 Jose Pedro Oliveira <jpo at di.uminho.pt> - 1.01-1
- Update to 1.01.
- New build requirement: perl(Test::Memory::Cycle).

* Thu Jan 25 2007 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.23-2
- perl(Set::Scalar) is no longer required.

* Wed Jan 24 2007 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.23-1
- Update to 0.23.
- New requirement: perl(B::Keywords).
- Author tests coverage improved.

* Sun Dec 17 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.22-2
- Enabled author tests.
- BR perl(HomeDir).

* Sun Dec 17 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.22-1
- Update to 0.22.

* Sat Nov 11 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.21-1
- Update to 0.21.
- New BR: perl(Set::Scalar).

* Sat Sep 16 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.2-1
- First build.
